"""
This module is used for reading the rst file.
"""

import numpy

def read_rstf(fname):

    fp = open(fname, 'r')
    Vp = []
    crds = []

    num = 1
    #Read the rst file
    for line in fp:
        if num >= 2:
            line = line.strip('\n')
            line = line.split()
            vals = []
        
            #get pure list
            for i in line:
                if i != '' and i != ' ':
                    vals.append(i)

            if len(vals) <= 2: #it is a atom number line
                try:
                    atnum = int(vals[0])
                except:
                    continue
            elif len(vals) >= 3: #it is coordinate line
                for i in vals:
                    crds.append(i)

        num = num + 1

    #Re-arrange the data
    crds = [float(i) for i in crds]
    crds = crds[0:3*atnum] #the coordinates
    boxs = crds[3*atnum:] #the last several values

    for i in range(0, atnum):
        Vp.append(numpy.array(crds[3*i:3*i+3]))
    V = numpy.array(Vp)
    return V


def write_rstf(outf, coord):

    fp = open(outf, 'w')

    num = len(coord)
    rows = num//2 + num%2

    print("Restart File Generated by pyMSMT", file=fp)
    print(" ", num, file=fp)
   
    for i in range(rows):
        if (2*i < num) and (2*i+1 < num):
            print("%12.7f%12.7f%12.7f%12.7f%12.7f%12.7f" %(coord[2*i][0],
                  coord[2*i][1], coord[2*i][2], coord[2*i+1][0],
                  coord[2*i+1][1], coord[2*i+1][2]), file=fp)
        else:
            print("%12.7f%12.7f%12.7f" %(coord[2*i][0], coord[2*i][1],
                  coord[2*i][2]), file=fp)
    fp.close()


